package org.black_ixx.bossshop.addon.guishopmanager;

import java.util.ArrayList;
import java.util.List;

import org.black_ixx.bossshop.addon.guishopmanager.Commander;
import org.black_ixx.bossshop.addon.guishopmanager.GSMItems;
import org.black_ixx.bossshop.addon.guishopmanager.PlayerListener;
import org.black_ixx.bossshop.api.BossShopAddon;
import org.bukkit.ChatColor;
import org.bukkit.command.CommandSender;
import org.bukkit.configuration.file.FileConfiguration;

public class GuiShopManager extends BossShopAddon {
	private GSMItems items;
	private PlayerListener listener;

	private void addDefaultConfig() {
		FileConfiguration c = getConfig();

		c.set("Version", getDescription().getVersion());
		c.set("Settings.AllowPlaceItems", Boolean.valueOf(false));
		c.set("Settings.AllowMoveItems", Boolean.valueOf(false));
		c.set("Settings.AllowDropItems", Boolean.valueOf(false));
		c.set("Settings.DropItemsOnDeath", Boolean.valueOf(false));
		c.set("Settings.GetItemsOnRespawn", Boolean.valueOf(true));

		List<String> compass = new ArrayList<String>();
		compass.add("name:&aQuick Warp &7(Right Click) &6[x]");
		compass.add("type:COMPASS");
		compass.add("amount:1");

		List<String> book = new ArrayList<String>();
		book.add("name:&6[o] &4&lBossShop &r&6Menu &6[o]");
		book.add("lore:&7Right Click to open the Menu!");
		book.add("type:BOOK");
		book.add("amount:1");

		c.set("Items.BossShopMenu.Look", book);
		c.set("Items.BossShopMenu.GiveOnJoin", Boolean.valueOf(true));
		c.set("Items.BossShopMenu.InventoryLocation", Integer.valueOf(1));
		c.set("Items.BossShopMenu.OpenShop", "menu");

		c.set("Items.Servers.Look", compass);
		c.set("Items.Servers.GiveOnJoin", Boolean.valueOf(true));
		c.set("Items.Servers.InventoryLocation", Integer.valueOf(9));
		c.set("Items.Servers.OpenShop", "bungeecordservers");

		saveConfig();
	}

	@Override
	public void bossShopReloaded(CommandSender sender) {
		reload();
		sender.sendMessage(ChatColor.YELLOW + "Reloaded BossShop Addon " + ChatColor.GOLD
				+ getAddonName());
	}

	@Override
	public void disableAddon() {
	}

	@Override
	public void enableAddon() {
		if (getConfig().getString("Version") == null) {
			addDefaultConfig();
		}

		this.items = new GSMItems(this);
		this.listener = new PlayerListener(this);
		getServer().getPluginManager().registerEvents(this.listener, this);

		getCommand("gsm").setExecutor(new Commander(this));
	}

	@Override
	public String getAddonName() {
		return "GuiShopManager";
	}

	public GSMItems getGSMItems() {
		return this.items;
	}

	@Override
	public String getRequiredBossShopVersion() {
		return "1.9.0";
	}

	public void reload() {
		reloadConfig();
		if (getConfig().getString("Version") == null) {
			addDefaultConfig();
		}
		this.items.reload(this);
		this.listener.reload(this);
	}
}